Package: CohortExplorer
Type: Package
Title: Explorer of Profiles of Patients in a Cohort
Version: 0.1.0
Date: 2023-10-22
Authors@R: c(
    person("Gowtham", "Rao", email = "rao@ohdsi.org", role = c("aut", "cre")),
    person("Observational Health Data Science and Informatics", role = c("cph"))
  )
Maintainer: Gowtham Rao <rao@ohdsi.org>
Description: This software tool is designed to extract data from a randomized subset of individuals 
    within a cohort and make it available for exploration in a shiny application environment. It 
    retrieves date-stamped, event-level records from one or more data sources that represent patient 
    data in the Observational Medical Outcomes Partnership (OMOP) data model format. This tool 
    features a user-friendly interface that enables users to efficiently explore the extracted 
    profiles, thereby facilitating applications, such as reviewing structured profiles.
Depends: DatabaseConnector (>= 5.0.0), R (>= 4.0.0)
Imports: checkmate, dplyr, lifecycle, ParallelLogger, rlang, stats
Suggests: rmarkdown, testthat, knitr, withr
License: Apache License
RoxygenNote: 7.2.3
VignetteBuilder: knitr
Encoding: UTF-8
Language: en-US
URL: https://ohdsi.github.io/CohortExplorer/,
        https://github.com/OHDSI/CohortExplorer
BugReports: https://github.com/OHDSI/CohortExplorer/issues
NeedsCompilation: no
Packaged: 2023-10-23 13:46:38 UTC; admin_grao9
Author: Gowtham Rao [aut, cre],
  Observational Health Data Science and Informatics [cph]
Repository: CRAN
Date/Publication: 2023-10-23 15:50:24 UTC
Built: R 4.2.0; ; 2023-10-23 19:18:25 UTC; unix

CohortExplorer

INSTALLATION

sudo dpkg -i debian/cohortexplorer_0.14-1_all.deb

To install dependencies type,
sudo apt-get install -f

or install
sudo apt-get install gdebi

and then,
sudo gdebi debian/cohortexplorer_0.14-1_all.deb

After the installation, the datasources can be configured by following the instructions in /etc/CohortExplorer/datasource-config.properties.

SECURITY

When installing CohortExplorer for group use, the administrator MUST ensure that:

a) MySQL connection parameters are for the read only mode (i.e. grant select only). 
b) At all times /etc/CohortExplorer/datasource-config.properties is only readable by the user 'cohexp'.
c) Log file is only readable by root/administrator or cohexp.


To uninstall type,

sudo apt-get purge cohortexplorer


SUPPORT AND DOCUMENTATION

After installation, you can find the documentation for CohortExplorer using the man command.

man CohortExplorer (Linux systems)

csvDownloadButton <- function(ns,
                              outputTableId,
                              buttonText = "Download CSV (filtered)") {
  shiny::tagList(shiny::tags$br(),
                 shiny::tags$button(
                   buttonText,
                   onclick = paste0("Reactable.downloadDataCSV('", outputTableId, "')")
                 ))
}

readData <- function(databaseId,
                     cohortId) {
  if (file.exists(file.path(
    "data",
    paste0("CohortExplorer_", cohortId, "_", databaseId, ".rds")
  ))) {
    return(readRDS(file = file.path(
      "data",
      paste0("CohortExplorer_", cohortId, "_", databaseId, ".rds")
    )))
  } else if (file.exists(file.path(
    "data",
    paste0("CohortExplorer_", cohortId, "_", databaseId, ".RDS")
  ))) {
    return(readRDS(file = file.path(
      "data",
      paste0("CohortExplorer_", cohortId, "_", databaseId, ".RDS")
    )))
  } else {
    return(NULL)
  }
}


snakeCaseToCamelCase <- function(string) {
  string <- tolower(string)
  for (letter in letters) {
    string <- gsub(paste("_", letter, sep = ""), toupper(letter), string)
  }
  string <- gsub("_([0-9])", "\\1", string)
  return(string)
}

camelCaseToTitleCase <- function(string) {
  string <- gsub("([A-Z])", " \\1", string)
  string <- gsub("([a-z])([0-9])", "\\1 \\2", string)
  substr(string, 1, 1) <- toupper(substr(string, 1, 1))
  return(string)
}

addDays <- function(x, n) {
  # Ensure that x is of class Date
  xAsDate <- as.Date(x)
  
  # Add n days to xAsDate
  newDate <- xAsDate + as.integer(n)
  
  return(newDate)
}

shinyUI(fluidPage(fluidRow(titlePanel(
  shiny::textOutput("cohortName")
),
column(
  2,
  shinyWidgets::pickerInput(
    inputId = "selectedDatabaseId",
    label = "Database id",
    choices = listOfFiles$databaseId %>% unique() %>% sort(),
    selected = initialSelectedDatabaseId,
    multiple = FALSE
  ),
  shinyWidgets::pickerInput(
    inputId = "selectedCohortId",
    label = "Cohort id",
    choices = listOfFiles$cohortId %>% unique() %>% sort(),
    selected = initialSelectedCohortId,
    multiple = FALSE
  ),
  tags$label(class = "control-label", `for` = "subjectId", "Subject ID"),
  textOutput("subjectId"),
  tags$label(class = "control-label", `for` = "age", "Age at First Index Date"),
  textOutput("age"),
  tags$label(class = "control-label", `for` = "gender", "Gender"),
  textOutput("gender"),
  actionButton("previousButton", "<"),
  actionButton("nextButton", ">"),
  checkboxGroupInput(
    "cdmTables",
    label = "Domains",
    choices = camelCaseToTitleCase(tables),
    selected = camelCaseToTitleCase(
      c(
        "visitOccurrence",
        "conditionOccurrence",
        "drugEra",
        "procedureOccurrence",
        "measurement",
        "observation"
      )
    )
  ),
  textAreaInput(
    "filterRegex",
    div(
      "Concept Name Filter (keep)",
      actionLink("filterInfo", "", icon = icon("info-circle"))
    ),
    placeholder = "regex",
    value = regexFilterInfo
  ),
  textAreaInput(
    "deleteRegex",
    div(
      "Concept Name Filter (remove)",
      actionLink("filterInfo", "", icon = icon("info-circle"))
    ),
    placeholder = "regex"
  ),
  numericInput(
    inputId = "daysFromCohortStart",
    label = "Absolute days from Start",
    min = 0,
    max = 9999,
    step = 1,
    value = 9999
  ),
  numericInput(
    inputId = "daysToCohortStart",
    label = "Absolute days to Start",
    min = 0,
    max = 9999,
    step = 1,
    value = 9999
  ),
  checkboxInput("showPlot", "Show Plot", value = TRUE),
  checkboxInput("showTable", "Show Table", value = TRUE),
  checkboxInput("shiftDates", "Shift Dates", value = FALSE),
  checkboxInput("showSourceCode", "Show source code", value = FALSE),
),
column(
  10,
  conditionalPanel(
    condition = "input.showTable==1",
    conditionalPanel(
      condition = "input.showPlot==1",
      plotly::plotlyOutput("plotSmall", height = "400px")
    ),
    shinycssloaders::withSpinner(reactable::reactableOutput(outputId = "eventTable")),
    csvDownloadButton(ns = "eventTable", "eventTable")
  ),
  conditionalPanel(condition = "input.showTable==0 & input.showPlot==1",
                   plotly::plotlyOutput("plotBig", height = "800px"),)
)
)))

library(magrittr)
source("R/private.R")

regexFilterInfo <- ""
if (file.exists("R/Default.R")) {
  source("R/Default.R")
}

files <- list.files(path = file.path("data"), pattern = ".rds", ignore.case = TRUE)
if (length(files) == 0) {
  stop("No .rds found in data folder.")
}

listOfFiles <-
  dplyr::tibble(files = files)

if (nrow(listOfFiles) == 0) {
  stop("No data found.")
}

listOfFiles$newName <-
  gsub(
    pattern = "CohortExplorer_",
    replacement = "",
    fixed = TRUE,
    x = listOfFiles$files
  )
listOfFiles$newName <-
  gsub(
    pattern = ".rds",
    replacement = "",
    fixed = TRUE,
    x = gsub(pattern = ".RDS", replacement = ".rds", x = listOfFiles$newName)
  )
listOfFiles <- listOfFiles %>%
  tidyr::separate(
    col = newName,
    sep = "_",
    into = c("cohortId", "databaseId")
  ) %>%
  dplyr::arrange(cohortId, databaseId)


initialSelectedCohortId <- listOfFiles[1, ]$cohortId
initialSelectedDatabaseId <- listOfFiles[1, ]$databaseId

tables <- c(
  "featureCohortData",
  "conditionEra",
  "conditionOccurrence",
  "drugEra",
  "drugExposure",
  "procedureOccurrence",
  "measurement",
  "observation",
  "visitOccurrence"
)

shinyServer(function(input, output, session) {
  subject <- shiny::reactiveValues(index = 1)
  
  dataFromRds <- shiny::reactive({
    readData(
      databaseId = input$selectedDatabaseId,
      cohortId = input$selectedCohortId
    )
  })
  subjectIds <- shiny::reactive({
    dataFromRds()$cohort$personId %>% sort()
  })
  
  selectedSubjectId <- shiny::reactive({
    if (subject$index) {
      subjectIds()[subject$index]
    }
  })
  
  cohortAndObservationPeriod <- shiny::reactive({
    cohortFiltered <- dataFromRds()$cohort %>%
      dplyr::filter(personId == subjectIds()[subject$index]) %>%
      dplyr::mutate(
        domain = "Cohort",
        cdmTable = "Cohort",
        conceptName = "Cohort entry",
        typeConceptName = "Cohort entry"
      ) %>%
      dplyr::select(startDate,
                    endDate,
                    domain,
                    conceptName,
                    typeConceptName,
                    cdmTable)
    
    observationPeriodFiltered <- dataFromRds()$observationPeriod %>%
      dplyr::filter(personId == subjectIds()[subject$index]) %>%
      dplyr::select(startDate,
                    endDate,
                    typeConceptId) %>%
      dplyr::mutate(cdmTable = "Observation Period",
                    domain = "Observation Period",
                    conceptName = "Observation Period") %>%
      dplyr::left_join(
        dataFromRds()$conceptId %>%
          dplyr::rename("typeConceptName" = "conceptName") %>%
          dplyr::select(-domainId),
        by = c("typeConceptId" = "conceptId")
      )
    
    data <- dplyr::bind_rows(cohortFiltered,
                             observationPeriodFiltered) %>%
      dplyr::arrange(cdmTable, startDate)
    
    data$firstOccurrenceDate <- min(cohortFiltered$startDate)
    
    return(data)
  })
  
  
  queryResult <- shiny::reactive({
    filteredConceptIds <- dataFromRds()$conceptId
    if (is.null(input$cdmTables)) {
      return(cohortAndObservationPeriod())
    } else {
      if (input$filterRegex != "") {
        tryCatch(
          expr = {
            filteredConceptIds <- filteredConceptIds %>%
              dplyr::filter(stringr::str_detect(
                string = tolower(conceptName),
                pattern = tolower(input$filterRegex)
              ))
          },
          error = function(e) {
            showNotification("please check the regular expression for error", "", type = "error")
            return()
          }
        )
      }
      
      if (input$deleteRegex != "") {
        tryCatch(
          expr = {
            filteredConceptIds <- filteredConceptIds %>%
              dplyr::filter(stringr::str_detect(
                string = tolower(conceptName),
                pattern = tolower(input$deleteRegex),
                negate = TRUE
              ))
          },
          error = function(e) {
            showNotification("please check the regular expression for error", "", type = "error")
            return()
          }
        )
      }
      selectedCdmTables <-
        gsub(
          pattern = " ",
          replacement = "_",
          x = tolower(input$cdmTables)
        )
      
      data <- dplyr::tibble()
      
      for (i in (1:length(selectedCdmTables))) {
        domainTableData <-
          dataFromRds()[[snakeCaseToCamelCase(selectedCdmTables[[i]])]] %>%
          dplyr::filter(personId == subjectIds()[subject$index]) %>%
          dplyr::mutate(cdmTable = selectedCdmTables[[i]])
        
        if (selectedCdmTables[[i]] == "feature_cohort_data") {
          cohortDefinitionSet <-
            dataFromRds()$featureCohortDefinitionSet |>
            dplyr::select(cohortId,
                          cohortName) |>
            dplyr::rename(conceptId = cohortId,
                          conceptName = cohortName)
        }
        
        if (!'endDate' %in% colnames(domainTableData)) {
          domainTableData <- domainTableData %>%
            dplyr::mutate(endDate = startDate)
        }
        
        domainTableData <- domainTableData %>%
          dplyr::mutate(endDate = dplyr::if_else(
            condition = is.na(endDate),
            true = startDate,
            false = endDate
          ))
        
        data <- dplyr::bind_rows(data,
                                 domainTableData)
      }
      
      if (input$showSourceCode) {
        data <- data %>%
          dplyr::filter(sourceConceptId >= 0) %>% 
          dplyr::mutate(conceptId = sourceConceptId) %>%
          dplyr::select(-sourceConceptId) %>%
          dplyr::group_by(personId,
                          startDate,
                          endDate,
                          conceptId,
                          typeConceptId,
                          cdmTable) %>%
          dplyr::summarise(records = sum(records),
                           .groups = "keep") %>%
          dplyr::ungroup()
      } else {
        data <- data %>%
          dplyr::filter(conceptId >= 0) 
        if ("sourceConceptId" %in% colnames(data)) {
          data <- data %>% 
            dplyr::select(-sourceConceptId)
        }
        data <- data %>%
          dplyr::group_by(personId,
                          startDate,
                          endDate,
                          conceptId,
                          typeConceptId,
                          cdmTable) %>%
          dplyr::summarise(records = sum(records),
                           .groups = "keep") %>%
          dplyr::ungroup()
      }
      
      dataFiltered <- data |> 
        dplyr::filter(!cdmTable == "feature_cohort_data") %>%
        dplyr::inner_join(filteredConceptIds,
                          by = "conceptId")
      
      if (exists("cohortDefinitionSet")) {
        featureCohortData <- data |>
          dplyr::filter(cdmTable == "feature_cohort_data") |>
          dplyr::inner_join(cohortDefinitionSet,
                            by = "conceptId") |>
          dplyr::mutate(vocabularyId = "Cohort",
                        conceptCode = as.character(conceptId),
                        typeConceptId = 0,
                        records = 1)
        
        dataFiltered <- dplyr::bind_rows(dataFiltered,
                                         featureCohortData)
      }
      
      data <- dataFiltered
      
      if (isFALSE(input$showSourceCode)) {
        data <- data %>%
          dplyr::select(-conceptCode, -vocabularyId)
      }
      
      data <- data %>%
        dplyr::left_join(
          dataFromRds()$conceptId %>%
            dplyr::rename("typeConceptName" = "conceptName") %>%
            dplyr::select(-domainId, -vocabularyId, -conceptCode),
          by = c("typeConceptId" = "conceptId")
        ) %>%
        dplyr::select(-typeConceptId)
      
      data <- data %>%
        dplyr::rename(domain = domainId) %>%
        dplyr::select(-personId)
      firstOccurrenceDateValue <-
        cohortAndObservationPeriod()$firstOccurrenceDate %>% unique()
      
      cohortData <-
        cohortAndObservationPeriod() %>% dplyr::select(intersect(colnames(data),
                                                                 colnames(cohortAndObservationPeriod())))
      
      data <- dplyr::bind_rows(cohortData,
                               data) %>%
        dplyr::mutate(daysToFirst = firstOccurrenceDateValue - startDate)
      
      if (all(!is.null(input$daysFromCohortStart),
              input$daysFromCohortStart != '')) {
        data <- data %>%
          dplyr::filter(as.integer(daysToFirst) * -1 <= input$daysFromCohortStart)
      }
      
      if (all(!is.null(input$daysToCohortStart),
              input$daysFromCohortStart != '')) {
        data <- data %>%
          dplyr::filter(as.integer(daysToFirst) <= input$daysToCohortStart)
      }
      
      if (isTRUE(input$shiftDates)) {
        earliestDate <- cohortAndObservationPeriod() %>%
          dplyr::select(startDate) %>%
          dplyr::summarise(startDate = as.Date(min(startDate))) %>%
          dplyr::pull(startDate)
        
        data <- data %>%
          dplyr::mutate(startDate = addDays(x = as.Date(originDate),
                                            n = as.integer(
                                              difftime(
                                                time1 = startDate,
                                                time2 = earliestDate,
                                                units = "days"
                                              )
                                            ))) %>%
          dplyr::mutate(endDate = addDays(x = as.Date(originDate),
                                          n = as.integer(
                                            difftime(
                                              time1 = endDate,
                                              time2 = earliestDate,
                                              units = "days"
                                            )
                                          )))
      }
      return(data)
    }
  })
  
  filteredEvents <- shiny::reactive({
    events <- queryResult()
    if (nrow(events) != 0) {
      events <- events[order(events$conceptId), ]
      getY <- function(subset) {
        uniqueConceptIds <- unique(subset$conceptId)
        subset$y <- match(subset$conceptId, uniqueConceptIds)
        return(subset)
      }
      events <- lapply(split(events, events$cdmTable), getY)
      events <- do.call("rbind", events)
    }
    return(events)
  })
  
  
  colorScale <- shiny::reactive({
    selectedCdmTables <- input$cdmTables
    if (length(selectedCdmTables) > 0) {
      selectedCdmTables <-
        gsub(
          pattern = " ",
          replacement = "_",
          x = tolower(selectedCdmTables)
        )
    }
    
    tables <- c("Cohort", "Observation Period", selectedCdmTables)
    if (length(tables) == 2) {
      colors <- c("Red", "Orange")
    } else {
      temp <-
        RColorBrewer::brewer.pal(n = max(3, length(tables) - 2), name = "Set2")
      colors <- c("Red", "Orange", temp[1:(length(tables) - 2)])
    }
    names(colors) <- tables
    return(colors)
  })
  
  shiny::observeEvent(input$nextButton, {
    if (subject$index < length(subjectIds())) {
      subject$index <- subject$index + 1
    }
  })
  
  shiny::observeEvent(input$previousButton, {
    if (subject$index > 1) {
      subject$index <- subject$index - 1
    }
  })
  
  output$cohortName <- shiny::renderText({
    cohortName <- "Unknown"
    if (!is.null(dataFromRds()$cohortName)) {
      cohortName <- dataFromRds()$cohortName
    }
    return(cohortName)
  })
  
  output$subjectId <- shiny::renderText({
    return(subjectIds()[subject$index])
  })
  
  output$age <- shiny::renderText({
    selectedSubjectId <- subjectIds()[subject$index][1]
    age <- dataFromRds()$person %>%
      dplyr::filter(personId == selectedSubjectId) %>%
      dplyr::pull(age)
    return(age)
  })
  
  output$gender <- shiny::renderText({
    selectedSubjectId <- subjectIds()[subject$index][1]
    gender <- dataFromRds()$subjects %>%
      dplyr::filter(personId == selectedSubjectId) %>%
      dplyr::pull(gender)
    return(gender)
  })
  
  output$eventTable <- reactable::renderReactable(expr = {
    data <- filteredEvents() %>%
      dplyr::arrange(abs(daysToFirst)) %>%
      dplyr::select(-conceptId, -y) %>%
      dplyr::relocate(daysToFirst,
                      conceptName,
                      typeConceptName,
                      startDate,
                      endDate,
                      domain,
                      cdmTable)
    
    colnames(data) <-
      camelCaseToTitleCase(colnames(data))
    
    dataTable <- reactable::reactable(
      data = data,
      sortable = TRUE,
      resizable = TRUE,
      filterable = TRUE,
      searchable = TRUE,
      pagination = TRUE,
      showPagination = TRUE,
      showPageInfo = TRUE,
      highlight = TRUE,
      striped = TRUE,
      compact = TRUE,
      showSortIcon = TRUE,
      showSortable = TRUE,
      fullWidth = TRUE,
      borderless = TRUE,
      onClick = "select",
      wrap = TRUE,
      showPageSizeOptions = TRUE,
      pageSizeOptions = c(10, 20, 50, 100, 1000),
      defaultPageSize = 1000
    )
    return(dataTable)
  })
  
  output$plotSmall <- plotly::renderPlotly(plot())
  output$plotBig <- plotly::renderPlotly(plot())
  
  plot <- shiny::reactive({
    events <- filteredEvents()
    if (nrow(events) == 0) {
      return(NULL)
    } else {
      colors <- colorScale()
      cdmTables <- events %>% 
        dplyr::group_by(cdmTable) %>% 
        dplyr::summarise(y = max(y), .groups = "keep") %>% 
        dplyr::ungroup()
      cdmTables <- cdmTables[order(cdmTables$cdmTable), ]
      cdmTables$offset <- cumsum(cdmTables$y) - cdmTables$y
      events <- merge(events, cdmTables[, c("cdmTable", "offset")])
      events$y <- events$y + events$offset
      yRange <- c(min(events$y) - 1, max(events$y) + 1)
      events$text <-
        sprintf(
          "%s - %s<br>%s<br>%s<br>%s<br>%s<br>%s",
          events$startDate,
          events$endDate,
          events$conceptName,
          events$conceptId,
          events$domain,
          events$cdmTable,
          events$typeConceptName
        )
      
      eventsPerY <- events %>%
        dplyr::group_by(y) %>%
        dplyr::summarise(cdmTable = length(y), .groups = "keep") %>% 
        dplyr::ungroup()
      
      yGrid <- eventsPerY$y[eventsPerY$cdmTable > 1]
      
      yAxis <- list(
        title = "",
        tickmode = "array",
        tickvals = yGrid,
        zeroline = FALSE,
        showline = FALSE,
        showticklabels = FALSE,
        showgrid = TRUE,
        range = yRange,
        fixedrange = TRUE
      )
      xAxis <- list(
        title = "",
        zeroline = FALSE,
        showline = FALSE,
        showticklabels = TRUE,
        showgrid = TRUE
      )
      plot <- plotly::plot_ly() %>%
        plotly::add_trace(
          data = events,
          x = ~ startDate,
          y = ~ y,
          color = ~ cdmTable,
          colors = colors,
          type = 'scatter',
          mode = 'markers',
          text = ~ text,
          hovertemplate = "%{text}"
        ) %>%
        plotly::add_segments(
          data = events,
          x = ~ startDate,
          y = ~ y,
          xend = ~ endDate,
          yend = ~ y,
          color = ~ cdmTable,
          showlegend = FALSE,
          hoverinfo = "skip"
        )
      
      shapes <- list()
      
      cohortData <- events %>%
        dplyr::filter(cdmTable == "Cohort") %>%
        dplyr::select(startDate,
                      endDate) %>%
        dplyr::distinct() %>%
        dplyr::arrange(startDate)
      
      first <- TRUE
      for (i in (1:nrow(cohortData))) {
        data <- data.frame(
          date = rep(cohortData$startDate[i], 2),
          y = rep(yRange, 2),
          text = sprintf("%s - %s",
                         cohortData$startDate[i],
                         cohortData$endDate[i])
        )
        plot <- plot %>% plotly::add_lines(
          x = ~ date,
          y = ~ y,
          data = data,
          mode = "lines",
          line = list(color = colors["Cohort"]),
          name = "Cohort",
          text = ~ text,
          hovertemplate = "%{text}",
          showlegend = first
        )
        first <- FALSE
        
        if (!is.na(cohortData$endDate[i])) {
          shapes[[length(shapes) + 1]] <- list(
            type = "rect",
            fillcolor = "red",
            line = list(color = colors["Cohort"]),
            opacity = 0.3,
            x0 = cohortData$startDate[i],
            x1 = cohortData$endDate[i],
            xref = "startDate",
            y0 = yRange[1],
            y1 = yRange[2],
            yref = "y"
          )
        }
      }
      
      plot <- plot %>% plotly::layout(
        yaxis = yAxis,
        xaxis = xAxis,
        shapes = shapes,
        legend = list(orientation = 'h'),
        margin =  list(
          l = 1,
          r = 1,
          b = 1,
          t = 25,
          pad = 1
        )
      )
      return(plot)
    }
  })
  
  shiny::observeEvent(input$filterInfo, {
    showModal(
      modalDialog(
        title = "Concept Name Filter",
        easyClose = TRUE,
        footer = NULL,
        size = "l",
        HTML(
          "Filter the concept to include in the plot and table by concept name using a regular expression.
           For example, the regular expression 'celecox|diclof' finds concepts like 'Celecoxib 200mg Oral Tablet' and 'Diclofenac'.
           See <a href='https://en.wikipedia.org/wiki/Regular_expression'>Wikipedia</a> for more information on regular expressions."
        )
      )
    )
  })
})

menuItemFileInput <-
  function(inputId,
           text,
           icon = shiny::icon("file-text-o")) {
    script <- "document.getElementById('%id%').click(); return false;"
    script <- gsub("%id%", inputId, script)
    list(div(fileInput(inputId, ""), style = "display: none;"),
         tags$li(class = "treeview", a(
           href = "#", onclick = script, icon, text
         )))
  }

menuItemDownloadLink <-
  function(inputId, label, icon = shiny::icon("floppy-o")) {
    tags$li(
      class = "treeview",
      tags$a(
        id = inputId,
        class = "shiny-download-link",
        href = "",
        target = "_blank",
        download = NA,
        icon,
        label
      )
    )
  }

menuItemCopyTextAreaToClipboard <-
  function(textAreaId,
           label,
           icon = shiny::icon("clipboard")) {
    script <- "
  element = $('<textarea>').appendTo('body').val(document.getElementById('%id%').value).select();
  document.execCommand('copy');
  element.remove();
  return false;
  "
    script <- gsub("%id%", textAreaId, script)
    tags$li(class = "treeview", a(href = "#", onclick = script, icon, label))
  }

menuItemCopyDivToClipboard <-
  function(divId, label, icon = shiny::icon("clipboard")) {
    script <- "
  element = $('<textarea>').appendTo('body').val(document.getElementById('%id%').textContent).select();
  document.execCommand('copy');
  element.remove();
  return false;
  "
    script <- gsub("%id%", divId, script)
    tags$li(class = "treeview", a(href = "#", onclick = script, icon, label))
  }

---
title: "How to use Cohort Explorer"
author: "Gowtham A. Rao"
date: "`r Sys.Date()`"
output:
  html_document:
    number_sections: yes
    toc: yes  
  pdf_document: 
    toc: yes     
vignette: >
  %\VignetteIndexEntry{How to use Cohort Explorer}
  %\VignetteEncoding{UTF-8}    
  %\VignetteEngine{knitr::rmarkdown}
---

```{r, echo = FALSE, message = FALSE}
knitr::opts_chunk$set(
  cache = FALSE,
  comment = "#>",
  error = FALSE,
  tidy = FALSE
)
```

# Introduction

This software tool is designed to extract data from a randomized subset of individuals within a cohort and make it available for exploration in a 'Shiny' application environment. It retrieves date-stamped, event-level records from one or more data sources that represent patient data in the Observational Medical Outcomes Partnership (OMOP) data model format. This tool features a user-friendly interface that enables users to efficiently explore the extracted profiles, thereby facilitating applications, such as reviewing structured profiles. The output of this R-package is a self-contained R shiny that contains person-level data for review.


## Warning:
- Contains person level data. This package is not to be considered de-identified.
- Please do not share the output with others as it may violate protected health information.
- .RDS file in output contains PHI.


## Assumptions:
- You have instantiated a valid cohort in a cohort table.
- You have access to person level data in the OMOP CDM V5.x + format on a database.
- You only need read access to the person level data. But you should have privileges to join the cohort table in the cohortDatabaseSchema with the person level data in the cdmDatabaseSchema.
- You have installed R and R-studio as described in the [Book of OHDSI](https://ohdsi.github.io/TheBookOfOhdsi/SqlAndR.html)

cohortDatabaseSchema: Schema name where your cohort tables reside.
cdmDatabaseSchema: Schema name where your OMOP CDM tables with person level data reside.


# Creating the shiny application

CohortExplorer has one function createCohortExplorerApp that when properly configured will connect to your database, check if the cohort table is instantiated, identify (random) sample of persons, extract their person level data, compile the output into an executable shiny application that may be executed.

Example: in the configuration example shown below, your output folder is "D:/myProject". The output will be created in that location.

```
connectionDetails <-
  DatabaseConnector::createConnectionDetails(
    dbms = "postgresql",
    server = "some.server.com/ohdsi",
    user = "joe",
    password = "secret"
  )

createCohortExplorerApp <- function(connectionDetails = connectionDetails,
                                    cohortDatabaseSchema = "cohort",
                                    cdmDatabaseSchema = "CDM",
                                    vocabularyDatabaseSchema = "CDM",
                                    cohortTable = "myCohortTable",
                                    cohortDefinitionId,
                                    cohortName = "personsWithSomeDisease",
                                    sampleSize = 25,
                                    exportFolder = "D:/myProject",
                                    databaseId,
                                    shiftDates = FALSE,
                                    assignNewId = FALSE)
```

In the exportFolder location there will be a 

![CohortExplorerShiny](FolderLocation.png)


Inside that folder is the 

![Shiny App.](ShinyApp.png).

## How to run app locally
Please ensure all R and R-studio sessions are closed on your computer. Then, double click the file CohortExplorer.Rproj. This will start RStudio. We recommend that you now run renv::restore() as it will set up all R package dependencies and if executed properly will ensure your app will run smoothly. You can then start the shiny app by typing in R studio console

![Shiny::runApp()](RunApp.png)

## How to run app on a R Studio server
Please zip the CohortExplorerShiny folder into one zip file and upload to the folder on the remote R studio server. The name of the folder in the remote R studio server should become the published Shiny App name (url)
